from abc import ABC, abstractmethod 
from ....autogeneratedscript.abstract.i_module_variable_writer import IModulevariableWriter
from .i_override_auto_nav_locator import IOverrideNavLocator


class IModuleLocatorWriter(IModulevariableWriter, IOverrideNavLocator, ABC):
    """
    This abstract class is designed for holding the blueprint structure of managing the
    locator writing process in a proper discipline. This is a child of IModulevariableWriter,
    which is also a abstract child class of IModuleWriter abstract class. 
    © BRAIN STATION 23 | Design and Development: Md. Ariful Islam (BS1121)
    """
    
    @abstractmethod
    def arrange_locator_by_type(self, locators_name: str,locators_value: dict):
        """This method will take Locator name and a dictionary as a value where key will be the 
        locator type as a parameter and then prepare string where locator types will be
        concatenated with variable name at the end. ©BS23"""